clc;clear;close all;
disp('In order to obtain the source code please visit');
disp('http://www.advancedsourcecode.com/lsbsteganography.asp');
disp(' ');
disp('Luigi Rosa');
disp('Via Centrale 35');
disp('67042 Civita Di Bagno');
disp('L''Aquila - ITALY');
disp('mobile +39 3207214179');
disp('email luigi.rosa@tiscali.it');
disp('website http://www.advancedsourcecode.com/');
disp(' ');
disp(' ');
I       = imread('lena.bmp');
rand('state', 0);
message = round(rand(100000,1));
Lm      = numel(message);
% Hiding secret message
[Irec] = hidebits(I,message);
% Performance evaluation
I0     = double(I);
I1     = double(Irec);
Id     = (I0-I1);
signal = sum(sum(I0.^2));
noise  = sum(sum(Id.^2));
SNR    = 10*log10(signal/noise);
disp('SNR Signal to Noise Ratio');
disp(SNR);
MSE  = noise/numel(I0);
peak = max(I0(:));
PSNR = 10*log10(peak^2/MSE);
disp('PSNR Peak Signal to Noise Ratio');
disp(PSNR);
% Plotting
figure,subplot(1,2,1),imshow(I),title('Cover image');
subplot(1,2,2),imshow(Irec),title('Stego Image');
%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
% Revealing secret message
[rec_message] = recoverbits(Irec,Lm);
% Bit error rate
disp('Bit error rate');
disp(nnz(message-rec_message)/numel(message));